      subroutine gridcheck_nests()
********************************************************************************
* $Id: gridcheck_nests.f,v 1.1 2006/06/21 09:51:34 paul Exp paul $
* $Log: gridcheck_nests.f,v $
* Revision 1.1  2006/06/21 09:51:34  paul
* Initial revision
*
*                                                                              *
*     This routine checks the grid specification for the nested model domains. *
*     It is similar to subroutine gridcheck, which checks the mother domain.   *
*                                                                              *
*     Authors: A. Stohl, G. Wotawa                                             *
*                                                                              *
*     8 February 1999                                                          *
********************************************************************************

      include 'includepar'
      include 'includecom'

      integer i,j,k,l,ifn,ifield,iumax,iwmax,numskip,nlev_ecn
      integer nuvzn,nwzn
!      real akmn(nwzmax),bkmn(nwzmax),akzn(nuvzmax),bkzn(nuvzmax)
      real sigmahalfn(nuvzmax),p00_mother,ptop_mother,ts0_mother
      real dxpn(maxnests),dypn(maxnests)
      real ta_mother
      real xaux1,xaux2,yaux1,yaux2

* VARIABLES AND ARRAYS NEEDED FOR GRIB DECODING

C dimension of isec2 at least (22+n), where n is the number of parallels or
C meridians in a quasi-regular (reduced) Gaussian or lat/long grid

C dimension of zsec2 at least (10+nn), where nn is the number of vertical
C coordinate parameters

      integer isec0(2),isec1(56),isec2(22+nxmaxn+nymaxn),isec3(2)
      integer isec4(64),inbuff(jpack),ilen,iswap,ierr,iword,lunit
      real zsec2(60+2*nuvzmax),zsec3(2),zsec4(jpunp)
      character*1 yoper
      data yoper/'D'/
      real xr,yr

      xresoln(0)=1.       ! resolution enhancement for mother grid
      yresoln(0)=1.       ! resolution enhancement for mother grid

C Loop about all nesting levels
*******************************

      do 300 l=1,numbnests

        iumax=0
        iwmax=0

        if(ideltas.gt.0) then
          ifn=1
        else
          ifn=numbwf
        endif
*
* OPENING OF DATA FILE (GRIB CODE)
*
5       call pbopen(lunit,path(numpath+2*(l-1)+1)
     +       (1:len(numpath+2*(l-1)+1))//wfnamen(l,ifn),'r',ierr)
        if(ierr.lt.0) goto 999

        ifield=0   
10        ifield=ifield+1
*
* GET NEXT FIELDS
*
          call pbgrib(lunit,inbuff,jpack,ilen,ierr)
          if(ierr.eq.-1) goto 30    ! EOF DETECTED
          if(ierr.lt.-1) goto 999   ! ERROR DETECTED
 
          ierr=1

C Check whether we are on a little endian or on a big endian computer
*********************************************************************

c         if (inbuff(1).eq.1112101447) then         ! little endian, swap bytes
c           iswap=1+ilen/4
c           call swap32(inbuff,iswap)
c         else if (inbuff(1).ne.1196575042) then    ! big endian
c           stop 'subroutine gridcheck: corrupt GRIB data'
c         endif

          call gribex(isec0,isec1,isec2,zsec2,isec3,zsec3,isec4,
     +    zsec4,jpunp,inbuff,jpack,iword,yoper,ierr)
          if (ierr.ne.0) goto 999   ! ERROR DETECTED

          if(ifield.eq.1) then
            nxn(l)=isec2(2)
            nyn(l)=isec2(3)

CPSK
C READ IN GRID SPECIFICATIONS

        open(unitwind,file=path(numpath+2*(l-1)+1)
     &           (1:len(numpath+2*(l-1)+1))//'GRID.TXT',
     &       status='old',err=996)
!     
        read(unitwind,*) codep
        if(codep.ne.1) goto 995
        codep=3                  !In Terrain LC has code 1, but map_utils
!     uses 3 for LC
        read(unitwind,*) dum_nx
        if(dum_nx.ne.nxn(l)) goto 996
        read(unitwind,*) dum_ny
        if(dum_ny.ne.nyn(l))goto 997
        read(unitwind,*) nlev_ecn
        read(unitwind,*) dxpn(l)
        dxpn(l)=dxpn(l)*1000.   ! Reference unit = m
        dypn(l)=dxpn(l)                   ! Only dx=dy possible in MM5...
        read(unitwind,*) dum_nx_mother
        read(unitwind,*) dum_ny_mother
        read(unitwind,*) dum_dx_mother
        dum_dx_mother=dum_dx_mother*1000.
        dum_dy_mother=dum_dx_mother
        read(unitwind,*) knownip
        read(unitwind,*) knownjp
        read(unitwind,*) stdlonp
        read(unitwind,*) 
        read(unitwind,*) lon1p
        read(unitwind,*) lat1p
        read(unitwind,*)
        read(unitwind,*)
        read(unitwind,*) truelat1p
        read(unitwind,*) truelat2p
        read(unitwind,*) 
        read(unitwind,*) p00_mother
        read(unitwind,*) ptop_mother
        read(unitwind,*) ts0_mother
        read(unitwind,*) ta_mother
        do 15 k=1,nlev_ecn
 15       read(unitwind,*) sigmahalfn(nlev_ecn-k+1)

       call map_set(codep,lat1p,lon1p,knownip,knownjp,dxpn(l),stdlonp,
     &truelat1p,truelat2p) 
       !save nest proj specs.
       ki_sav(l)=knownip
       kj_sav(l)=knownjp
       lat1n_sav(l)=proj_lat1
       lon1n_sav(l)=proj_lon1
       dxn_sav(l)=proj_dx

         call ij_to_latlon(0.,0.,yaux1,xaux1)
         call ij_to_latlon(float(nxn(l)-1),float(nyn(l)-1),yaux2,xaux2)
         
!         do 991 j=1,nyn(l)-1
!            do 991 i=1,nxn(l)-1
!               call ij_to_latlon(float(i),float(j),yr,xr) 
!               inlonn(i-1,j-1,l)=xr
!               inlatn(i-1,j-1,l)=yr
! 991     continue


!          xaux1=float(isec2(5))/1000.
!          xaux2=float(isec2(8))/1000.
          if(xaux1.gt.180) xaux1=xaux1-360.0
          if(xaux2.gt.180) xaux2=xaux2-360.0
          if(xaux1.lt.-180) xaux1=xaux1+360.0
          if(xaux2.lt.-180) xaux2=xaux2+360.0
          if (xaux2.lt.xaux1) xaux2=xaux2+360.
!          yaux1=float(isec2(7))/1000.
!          yaux2=float(isec2(4))/1000.
          xlon0n(l)=xaux1
          ylat0n(l)=yaux1
          dxn(l)=(xaux2-xaux1)/float(nxn(l)-1)
          dyn(l)=(yaux2-yaux1)/float(nyn(l)-1)
 
           
!          nlev_ecn=isec2(12)/2-1
       endif

     
          k=isec1(8)
          if(isec1(6).eq.131) iumax=max(iumax,nlev_ec-k+1)
          if(isec1(6).eq.135) iwmax=max(iwmax,nlev_ec-k+2) 


          if(isec1(6).eq.129) then
          do 20 j=0,nyn(l)-1
            do 20 i=0,nxn(l)-1
20              oron(i,j,l)=zsec4(nxn(l)*(nyn(l)-j-1)+i+1)
          endif
          
          if(isec1(6).eq.172) then
            do 25 j=0,nyn(l)-1
              do 25 i=0,nxn(l)-1
                if(int(zsec4(nxn(l)*(nyn(l)-j-1)+i+1)).eq.16) then
                  lsmn(i,j,l)=0.
                else
                  lsmn(i,j,l)=1.
                endif
 25          continue
          endif
c          if(isec1(6).eq.160) then
c          do 26 j=0,nyn(l)-1
c            do 26 i=0,nxn(l)-1
c26              excessoron(i,j,l)=zsec4(nxn(l)*(nyn(l)-j-1)+i+1)/ga
c          endif

          goto 10                 !! READ NEXT LEVEL OR PARAMETER
*
* CLOSING OF INPUT DATA FILE
*
30      call pbclose(lunit,ierr)     !! FINISHED READING / CLOSING GRIB FILE

        nuvzn=iumax
        nwzn=iwmax
        if(nuvzn.eq.nlev_ec) nwzn=nlev_ecn+1

        if (nxn(l).gt.nxmaxn) then
      write(*,*) 'FLEXPART error: Too many grid points in x direction.'
      write(*,*) 'Reduce resolution of wind fields (file GRIDSPEC)'
      write(*,*) 'for nesting level ',l
      write(*,*) 'Or change parameter settings in file includepar.'
      write(*,*) nxn(l),nxmaxn
          stop
        endif

        if (nyn(l).gt.nymaxn) then
      write(*,*) 'FLEXPART error: Too many grid points in y direction.'
      write(*,*) 'Reduce resolution of wind fields (file GRIDSPEC)'
      write(*,*) 'for nesting level ',l
      write(*,*) 'Or change parameter settings in file includepar.'
      write(*,*) nyn(l),nymaxn
          stop
        endif

        if ((nuvzn.gt.nuvzmax).or.(nwzn.gt.nwzmax)) then
      write(*,*) 'FLEXPART error: Nested wind fields have too many'//
     +'vertical levels.'
      write(*,*) 'Problem was encountered for nesting level ',l
          stop
        endif


C Output of grid info
*********************

      write(*,'(a,i2)') 'Nested domain #: ',l
      
	write(*,'(a,f10.1,a1,f10.1,a,f10.4,a,f10.4,i5)') 
     +'  Longitude range: ',
     +xlon0n(l),' to ',xlon0n(l)+(nxn(l)-1)*dxn(l),
     +'   Grid distance (ca. deg/meter): ',dxn(l),'/',dxpn(l),nxn(l)
      
	write(*,'(a,f10.1,a1,f10.1,a,f10.4,a,f10.4,i5)') 
	
     +'  Latitude range:  ',
     +ylat0n(l),' to ',ylat0n(l)+(nyn(l)-1)*dyn(l),
     +'   Grid distance (ca. deg/meter): ',dyn(l),'/',dypn(l),nyn(l)
     
      write(*,*)

C Determine, how much the resolutions in the nests are enhanced as
C compared to the mother grid
******************************************************************

        xresoln(l)=dx_sav/dxpn(l)!dx/dxn(l)
        yresoln(l)= xresoln(l)   !dy/dyn(l)

C Determine the mother grid coordinates of the corner points of the
C nested grids
C Convert first to geographical coordinates, then to grid coordinates
*********************************************************************
CPSK FIXXME

        call ij_to_latlon(0.,0.,yaux1,xaux1)
        call ij_to_latlon(float(nxn(l)-1),float(nyn(l)-1),yaux2,xaux2)

! Set map back to mother
        call map_set(code_sav,lat1_sav,lon1_sav,1.,1.,dx_sav,stdlon_sav
     &       ,truelat1_sav,truelat2_sav)
        call latlon_to_ij(yaux1,xaux1,xln(l),yln(l))
        call latlon_to_ij(yaux2,xaux2,xrn(l),yrn(l))

        if ((xln(l).lt.0.).or.(yln(l).lt.0.).or.
     +  (xrn(l).gt.float(nxmin1)).or.(yrn(l).gt.float(nymin1))) then
          write(*,*) 'Nested domain does not fit into mother domain'
          write(*,*) 'For global mother domain fields, you can shift'
          write(*,*) 'shift the mother domain into x-direction'
          write(*,*) 'by setting nxshift (file includepar) to a'
          write(*,*) 'positive value. Execution is terminated.'
          stop
        endif
CPSK FIXXME

* CALCULATE VERTICAL DISCRETIZATION OF ECMWF MODEL
* PARAMETER akm,bkm DESCRIBE THE HYBRID "ETA" COORDINATE SYSTEM
!
!        numskip=nlev_ecn-nuvzn ! number of ecmwf model layers not used by FLEXPART
!        do 40 i=1,nwzn
!          j=numskip+i
!          k=nlev_ecn+1+numskip+i
!          akmn(nwzn-i+1)=zsec2(10+j)
!40        bkmn(nwzn-i+1)=zsec2(10+k)

*
* CALCULATION OF AKZ, BKZ
* AKZ,BKZ: model discretization parameters at the center of each model
*          layer
*
C Assign the 10 m winds to an artificial model level with akz=0 and bkz=1.0,
C i.e. ground level
******************************************************************************
! 
!        akzn(1)=0.
!        bkzn(1)=1.0
!        do 90 i=1,nuvzn
!          akzn(i+1)=0.5*(akmn(i+1)+akmn(i))
!          bkzn(i+1)=0.5*(bkmn(i+1)+bkmn(i))
!90        continue
        nuvzn=nuvzn+1

C Check, whether the heights of the model levels of the nested
C wind fields are consistent with those of the mother domain.
C If not, terminate model run.
**************************************************************

        if(nlev_ec.ne.nlev_ecn)then
         write(*,*) 'FLEXPART error: The wind fields of nesting level',l
         write(*,*) 'are not consistent with the mother domain:'
         write(*,*) 'Differences in vertical levels detected.'
         stop
        endif

!        do 85 i=1,nwz
!          if ((akmn(i).ne.akm(i)).or.(bkmn(i).ne.bkm(i))) then
!      write(*,*) 'FLEXPART error: The wind fields of nesting level',l
!      write(*,*) 'are not consistent with the mother domain:'
!      write(*,*) 'Differences in vertical levels detected.'
!            stop
!          endif
!85        continue

300     continue

      return

 995  write(*,*)
      write(*,*) ' ###########################################'//
     &           '###### '
      write(*,*) '       TRAJECTORY MODEL SUBROUTINE GRIDCHECK:'
      write(*,*) 'AT PRESENT, ONLY LAMBERT CONFORMAL PROJECTION'
      write(*,*) 'IS SUPPORTED.'
      write(*,*) ' ###########################################'//
     &     '###### '

 996  write(*,*)
      write(*,*) ' ###########################################'//
     &           '###### '
      write(*,*) '       TRAJECTORY MODEL SUBROUTINE GRIDCHECK:'
      write(*,*) 'GRID POINTS X ARE NOT THE SAME, PLEASE CHECK '
      write(*,*) 'GRID.TXT AND/OR MM5-INPUTFILES'
      write(*,*) ' ###########################################'//
     &     '###### '

 997  write(*,*)
      write(*,*) ' ###########################################'//
     &           '###### '
      write(*,*) '       TRAJECTORY MODEL SUBROUTINE GRIDCHECK:'
      write(*,*) 'GRID POINTS Y ARE NOT THE SAME, PLEASE CHECK '
      write(*,*) 'GRID.TXT AND/OR MM5-INPUTFILES'
      write(*,*) ' ###########################################'//
     &     '###### '

999   write(*,*)  
      write(*,*) ' ###########################################'//
     &           '###### '
      write(*,*) '                FLEXPART SUBROUTINE GRIDCHECK:'
      write(*,*) ' CAN NOT OPEN INPUT DATA FILE '//wfnamen(l,ifn)
      write(*,*) ' FOR NESTING LEVEL ',k
      write(*,*) ' ###########################################'//
     &           '###### '
      stop

      end
