      subroutine openouttraj()
********************************************************************************
* $Id: openouttraj.f,v 1.1 2006/08/09 07:47:56 paul Exp paul $
* $Log: openouttraj.f,v $
* Revision 1.1  2006/08/09 07:47:56  paul
* Initial revision
*
*                                                                              *
*   This routine opens the output file for the plume trajectory output         *
*   produced by the cluster analysis.                                          *
*                                                                              *
*     Author: A. Stohl                                                         *
*                                                                              *
*     27 January 2001                                                          *
*                                                                              *
********************************************************************************
*                                                                              *
* Variables:                                                                   *
*                                                                              *
********************************************************************************

      include 'includepar'
      include 'includecom'
      
      integer i
      real xp1,yp1,xp2,yp2


C Open output file for trajectory output
****************************************

      open(unitouttraj,file=path(2)(1:len(2))//'trajectories.txt',
     +form='formatted',err=998)

      if (ldirect.eq.1) then
      write(unitouttraj,'(i8,1x,i6,1x,a)') ibdate,ibtime,'FLEXPMM5 V6.2'
      else
      write(unitouttraj,'(i8,1x,i6,1x,a)') iedate,ietime,'FLEXPMM5 V6.2'
      endif
      write(unitouttraj,*) method,lsubgrid,lconvection
      write(unitouttraj,*) numpoint
      do 13 i=1,numpoint
        call ij_to_latlon(xpoint1(i),ypoint1(i),yp1,xp1)
        call ij_to_latlon(xpoint2(i),ypoint2(i),yp2,xp2)

C        xp1=xpoint1(i)*dx+xlon0
C        yp1=ypoint1(i)*dy+ylat0
C        xp2=xpoint2(i)*dx+xlon0
C        yp2=ypoint2(i)*dy+ylat0
        write(unitouttraj,*) ireleasestart(i),ireleaseend(i),
     +  xp1,yp1,xp2,yp2,zpoint1(i),zpoint2(i),kindz(i),npart(i)
        write(unitouttraj,'(a)') compoint(i)(1:40)
13      continue

      return

998   write(*,*) ' #### FLEXPART MODEL ERROR!   THE FILE         #### '
      write(*,*) ' #### trajectories.txt                         #### '
      write(*,*) ' #### CANNOT BE OPENED. IF A FILE WITH THIS    #### '
      write(*,*) ' #### NAME ALREADY EXISTS, DELETE IT AND START #### '
      write(*,*) ' #### THE PROGRAM AGAIN.                       #### '
      stop

      end
