      subroutine readwind_nests(indj,n,uuhn,vvhn,wwhn)
C                                i   i  o    o    o
********************************************************************************
* $Id: readwind_nests.f,v 1.1 2006/08/09 12:04:35 paul Exp paul $
* $Log: readwind_nests.f,v $
* Revision 1.1  2006/08/09 12:04:35  paul
* Initial revision
*
*                                                                              *
*     This routine reads the wind fields for the nested model domains.         *
*     It is similar to subroutine readwind, which reads the mother domain.     *
*                                                                              *
*     Authors: A. Stohl, G. Wotawa                                             *
*                                                                              *
*     8 February 1999                                                          *
*                                                                              *
*     Last update: 17 October 2000, A. Stohl                                   *
*                                                                              *
********************************************************************************
*  Changes, Bernd C. Krueger, Feb. 2001:
*        Variables tthn and qvhn (on eta coordinates) in common block
********************************************************************************


      include 'includepar'
      include 'includecom'

      real uuhn(0:nxmaxn-1,0:nymaxn-1,nuvzmax,maxnests)
      real vvhn(0:nxmaxn-1,0:nymaxn-1,nuvzmax,maxnests)
      real wwhn(0:nxmaxn-1,0:nymaxn-1,nuvzmax,maxnests) !nwzmax
      integer indj,i,j,k,n,levdiff2,ifield,iumax,iwmax,lunit,l
!      real tkehn(0:nxmaxn-1,0:nymaxn-1,nuvzmax,maxnests)
      real clwprofn(nuvzmax),ttprofn(nuvzmax)
      real cloudtop,cloudwater

* VARIABLES AND ARRAYS NEEDED FOR GRIB DECODING

C dimension of isec2 at least (22+n), where n is the number of parallels or
C meridians in a quasi-regular (reduced) Gaussian or lat/long grid

C dimension of zsec2 at least (10+nn), where nn is the number of vertical
C coordinate parameters

      integer isec0(2),isec1(56),isec2(22+nxmaxn+nymaxn),isec3(2)
      integer isec4(64),inbuff(jpack),ilen,iswap,ierr,iword
      real zsec2(60+2*nuvzmax),zsec3(2),zsec4(jpunp)
      real xaux,yaux,xaux0,yaux0
      real ewss(0:nxmaxn-1,0:nymaxn-1),nsss(0:nxmaxn-1,0:nymaxn-1)
      real plev1,pmean,tv,fu,hlev1,ff10m,fflev1

      character*1 yoper
      logical hflswitch,strswitch

      data yoper/'D'/

      do 100 l=1,numbnests
        hflswitch=.false.
        strswitch=.false.
        levdiff2=nlev_ec-nwz+1
        iumax=0
        iwmax=0

*
* OPENING OF DATA FILE (GRIB CODE)
*
5       call pbopen(lunit,path(numpath+2*(l-1)+1)
     +  (1:len(numpath+2*(l-1)+1))//wfnamen(l,indj),'r',ierr)
        if(ierr.lt.0) goto 999

        ifield=0
10        ifield=ifield+1
*
* GET NEXT FIELDS
*
        call pbgrib(lunit,inbuff,jpack,ilen,ierr)
        if(ierr.eq.-1) goto 50    ! EOF DETECTED
        if(ierr.lt.-1) goto 888   ! ERROR DETECTED

        ierr=1

C Check whether we are on a little endian or on a big endian computer
*********************************************************************

c       if (inbuff(1).eq.1112101447) then         ! little endian, swap bytes
c         iswap=1+ilen/4
c         call swap32(inbuff,iswap)
c       else if (inbuff(1).ne.1196575042) then    ! big endian
c         stop 'subroutine gridcheck: corrupt GRIB data'
c       endif

        call gribex(isec0,isec1,isec2,zsec2,isec3,zsec3,isec4,
     +  zsec4,jpunp,inbuff,jpack,iword,yoper,ierr)
        if (ierr.ne.0) goto 888   ! ERROR DETECTED

        if(ifield.eq.1) then

* CHECK GRID SPECIFICATIONS

          if(isec2(2).ne.nxn(l)) stop
     +    'READWIND: NX NOT CONSISTENT FOR A NESTING LEVEL'
          if(isec2(3).ne.nyn(l)) stop
     +    'READWIND: NY NOT CONSISTENT FOR A NESTING LEVEL'
          if(isec2(12).ne.nlev_ec) stop 'READWIND: VERTICAL DISCRET
     +IZATION NOT CONSISTENT FOR A NESTING LEVEL'

CPSK FIXXME NO LAT/LON VALUES IN GRIB !!
C          xaux=float(isec2(5))/1000.
C          yaux=float(isec2(7))/1000.
C          xaux0=xlon0n(l)
C          yaux0=ylat0n(l)
C          if(xaux.lt.0.) xaux=xaux+360.
C          if(yaux.lt.0.) yaux=yaux+360.
C          if(xaux0.lt.0.) xaux0=xaux0+360.
C          if(yaux0.lt.0.) yaux0=yaux0+360.
C          if(xaux.ne.xaux0)
C     +    stop 'READWIND: LOWER LEFT LONGITUDE NOT CONSISTENT FOR A NES
C     +TING LEVEL'
C          if(yaux.ne.yaux0)
C     +    stop 'READWIND: LOWER LEFT LATITUDE NOT CONSISTENT FOR A NEST
C     +ING LEVEL'
        endif

        do 20 j=0,nyn(l)-1
          do 20 i=0,nxn(l)-1
            k=isec1(8)
          if(isec1(6).eq.130) tthn(i,j,nlev_ec-k+1,n,l)=   !! TEMPERATURE
     &                        zsec4(nxn(l)*(nyn(l)-j-1)+i+1)
          if(isec1(6).eq.131) uuhn(i,j,nlev_ec-k+1,l)= !! U VELOCITY
     &                        zsec4(nxn(l)*(nyn(l)-j-1)+i+1)
 
          if(isec1(6).eq.132) vvhn(i,j,nlev_ec-k+1,l)=     !! V VELOCITY
     &                        zsec4(nxn(l)*(nyn(l)-j-1)+i+1)
          if(isec1(6).eq.133) then                      !! SPEC. HUMIDITY  
            qvhn(i,j,nlev_ec-k+2,n,l)=zsec4(nxn(l)*(nyn(l)-j-1)+i+1)
            if (qvhn(i,j,nlev_ec-k+2,n,l) .lt. 0.)
     $           qvhn(i,j,nlev_ec-k+2,n,l) = 0.
c             this is necessary because the gridded data may contain
c             spurious negative values
          endif
          if(isec1(6).eq.134) psn(i,j,1,n,l)=              !! REF. SURF. PRESS.
     &                        zsec4(nxn(l)*(nyn(l)-j-1)+i+1)

          if(isec1(6).eq.135) wwhn(i,j,nlev_ec-k+2,l)=     !! W VELOCITY
     &                        zsec4(nxn(l)*(nyn(l)-j-1)+i+1)
          if(isec1(6).eq.135.and.k.eq.1) wwhn(i,j,nlev_ec+1,l)=
     &                        zsec4(nxn(l)*(nyn(l)-j-1)+i+1)!!W VELOICTY AT PTOP
          
          if(isec1(6).eq.201) tkehn(i,j,nlev_ec-k+1,l)=     !! TKE
     &                        max(zsec4(nxn(l)*(nyn(l)-j-1)+i+1),1.e-4)
          
          if(isec1(6).eq.200) clwn(i,j,nlev_ec-k+1,n,l)=    !! CLOUD WATER
     &                        zsec4(nxn(l)*(nyn(l)-j-1)+i+1)

          if(isec1(6).eq.202) sdn(i,j,1,n,l)=              !! SNOW COVER
     &                        zsec4(nxn(l)*(nyn(l)-j-1)+i+1)

          if(isec1(6).eq.142) then                      !! LARGE SCALE PREC.
            lsprecn(i,j,1,n,l)=zsec4(nxn(l)*(nyn(l)-j-1)+i+1)
            if (lsprecn(i,j,1,n,l).lt.0.) lsprecn(i,j,1,n,l)=0.
          endif

          if(isec1(6).eq.143) then                      !! CONVECTIVE PREC.
            convprecn(i,j,1,n,l)=zsec4(nxn(l)*(nyn(l)-j-1)+i+1)
            if (convprecn(i,j,1,n,l).lt.0.) convprecn(i,j,1,n,l)=0.
          endif

          if(isec1(6).eq.146) sshfn(i,j,1,n,l)=            !! SENS. HEAT FLUX
     &                        -1.*zsec4(nxn(l)*(nyn(l)-j-1)+i+1)
          if((isec1(6).eq.146).and.(zsec4(nxn(l)*(nyn(l)-j-1)+i+1)
     &      .ne.0.))hflswitch=.true.    ! Heat flux available

          if(isec1(6).eq.176) then                      !! SOLAR RADIATION
            ssrn(i,j,1,n,l)=zsec4(nxn(l)*(nyn(l)-j-1)+i+1)
            if (ssrn(i,j,1,n,l).lt.0.) ssrn(i,j,1,n,l)=0.
          endif

          if(isec1(6).eq.180) ustarn(i,j,1,n,l)=           !! USTAR
     &                        zsec4(nxn(l)*(nyn(l)-j-1)+i+1)

          if(isec1(6).eq.204) hmixn(i,j,1,n,l)=            !! HMIX
     &                        zsec4(nxn(l)*(nyn(l)-j-1)+i+1)

C          if(((isec1(6).eq.180).or.(isec1(6).eq.181)).and.
C     &    (zsec4(nxfield*(ny-j-1)+i+1).ne.0.)) strswitch=.true.    ! stress available

          if(isec1(6).eq.129) oron(i,j,l)=                 !! ECMWF OROGRAPHY
     &                        zsec4(nxn(l)*(nyn(l)-j-1)+i+1)

          if(isec1(6).eq.172) then                      !! LAND SEA MASK
             if (int(zsec4(nxn(l)*(nyn(l)-j-1)+i+1)).eq.16) then
                lsmn(i,j,l)=0.      
             else
                lsmn(i,j,l)=1.
             endif
          endif
          if(isec1(6).eq.131) iumax=max(iumax,nlev_ec-k+1)
          if(isec1(6).eq.135) iwmax=max(iwmax,nlev_ec-k+2)
 20    continue

        goto 10                      !! READ NEXT LEVEL OR PARAMETER
*
* CLOSING OF INPUT DATA FILE
*
50      call pbclose(lunit,ierr)     !! FINISHED READING / CLOSING GRIB FILE

        if(levdiff2.eq.0) then
          iwmax=nlev_ec+1
          do 60 i=0,nxn(l)-1
            do 60 j=0,nyn(l)-1
60            wwhn(i,j,nlev_ec+1,l)=0.
        endif

C        do 65 i=0,nxn(l)-1
C          do 65 j=0,nyn(l)-1
C65          surfstrn(i,j,1,n,l)=sqrt(ewss(i,j)**2+nsss(i,j)**2)

C        if ((.not.hflswitch).or.(.not.strswitch)) then
C          write(*,*) 'WARNING: No flux data contained in GRIB file ',
C     +    wfnamen(l,indj)
C 
C CALCULATE USTAR AND SSHF USING THE PROFILE METHOD
C As ECMWF has increased the model resolution, such that now the first model
C level is at about 10 m (where 10-m wind is given), use the 2nd ECMWF level
C (3rd model level in FLEXPART) for the profile method
****************************************************************************
C
C          do 1500 i=0,nxn(l)-1
C            do 1500 j=0,nyn(l)-1
C            plev1=akz(3)+bkz(3)*psn(i,j,1,n,l)
C            pmean=0.5*(psn(i,j,1,n,l)+plev1)
C            tv=tthn(i,j,3,n,l)*(1.+0.61*qvhn(i,j,3,n,l))
C            fu=-r_air*tv/ga/pmean
C            hlev1=fu*(plev1-psn(i,j,1,n,l))   ! HEIGTH OF FIRST MODEL LAYER
C            ff10m= sqrt(u10n(i,j,1,n,l)**2+v10n(i,j,1,n,l)**2)
C            fflev1=sqrt(uuhn(i,j,3,l)**2+vvhn(i,j,3,l)**2)
C            call pbl_profile(psn(i,j,1,n,l),td2n(i,j,1,n,l),hlev1,
C     &           tt2n(i,j,1,n,l),tthn(i,j,3,n,l),ff10m,fflev1,
C     &           surfstrn(i,j,1,n,l),sshfn(i,j,1,n,l))
C            if(sshfn(i,j,1,n,l).gt.200.) sshfn(i,j,1,n,l)=200.
C            if(sshfn(i,j,1,n,l).lt.-400.) sshfn(i,j,1,n,l)=-400.
C1500        continue
C        endif


C Assign 10 m wind to model level at eta=1.0 to have one additional model
C level at the ground
C Specific humidity is taken the same as at one level above
C Temperature is taken as 2 m temperature         
***************************************************************************

        do 70 i=0,nxn(l)-1
          do 70 j=0,nyn(l)-1

C CALCULATE TOTAL INTEGRATED CLOUD WATER AND CLOUD TOP HEIGHT
************************************************************************
             do 61 k=1,nuvz-1
                ttprofn(k)  = tthn(i,j,k+1,n,l)
                clwprofn(k) = clwn(i,j,k,n,l)
 61          continue
             cltopn(i,j,1,n,l)=cloudtop(psn(i,j,1,n,l),clwprofn,
     &            nuvz-1,sigmafull,ptop,p00,ts0,ta)
             ticlwn(i,j,1,n,l)=cloudwater(psn(i,j,1,n,l),ttprofn,
     &            clwprofn,nuvz-1,sigmahalf,sigmafull,ptop,p00,ts0,ta)
             
            uuhn(i,j,1,l)=uuhn(i,j,2,l)
            vvhn(i,j,1,l)=vvhn(i,j,2,l)
            qvhn(i,j,1,n,l)=qvhn(i,j,2,n,l)
            tthn(i,j,1,n,l)=tthn(i,j,2,n,l)
            tkehn(i,j,1,l)=tkehn(i,j,2,l)
 70      continue

CPSK FIXXME nuvz-1 ?!?
        if(iumax.ne.nuvz-1) stop
     +  'READWIND: NUVZ NOT CONSISTENT FOR A NESTING LEVEL'
        if(iwmax.ne.nwz) stop
     +  'READWIND: NWZ NOT CONSISTENT FOR A NESTING LEVEL'

100     continue

      return    
888   write(*,*) ' #### FLEXPART MODEL ERROR! WINDFIELD         #### ' 
      write(*,*) ' #### ',wfnamen(l,indj),' FOR NESTING LEVEL  #### '
      write(*,*) ' #### ',l,' IS NOT GRIB FORMAT !!!           #### '
      stop 'Execution terminated'


999   write(*,*) ' #### FLEXPART MODEL ERROR! WINDFIELD         #### ' 
      write(*,*) ' #### ',wfnamen(l,indj),'                    #### '
      write(*,*) ' #### CANNOT BE OPENED FOR NESTING LEVEL ',l,'####'

      end
